#include "ntpTime.h"

#define TZ_Europe_Madrid	PSTR("CET-1CEST,M3.5.0,M10.5.0/3")
#define MYTZ TZ_Europe_Madrid
// initial time (possibly given by an external RTC)
#define RTC_UTC_TEST 1510592825 // 1510592825 = Monday 13 November 2017 17:07:05 UTC

time_t NtpTime::getUTC()
{
	return time(nullptr);
}

time_t NtpTime::getLocal()
{
	time_t tnow = time(nullptr);

	struct tm* local = localtime(&tnow);
	return mktime(local);
}

time_t NtpTime::tmConvert_t(int YYYY, byte MM, byte DD, byte hh, byte mm, byte ss, bool local = false)
{
	//time_t tm;
	//tmElements_t tmSet;
	//tmSet.Year = YYYY - 1970;
	//tmSet.Month = MM;
	//tmSet.Day = DD;
	//tmSet.Hour = hh;
	//tmSet.Minute = mm;
	//tmSet.Second = ss;
	//tm = makeTime(tmSet);
	//if (local)
	//{
	//	tm = tm - 120;			//Adjust for local time
	//}
	//return tm;
}

String NtpTime::getFullTimeDate() {
	timeval tv;
	timespec tp;
	time_t now;
	gettimeofday(&tv, nullptr);
	now = time(nullptr);
	return(ctime(&now));
}

//Function to print time
String NtpTime::getLocalTime()
{
	timeval tv;
	timespec tp;
	time_t now;
	gettimeofday(&tv, nullptr);
	now = time(nullptr);

	char temp[10];

	struct tm* local = localtime(&now);
	snprintf(temp, sizeof(temp), "%02d:%02d:%02d", local->tm_hour, local->tm_min, local->tm_sec);
	hourT = local->tm_hour;
	minuteT = local->tm_min;
	secondT = local->tm_sec;
	dayT = local->tm_mday;
	monthT = local->tm_mon + 1;
	yearT = local->tm_year + 1900;
	year2 = local->tm_year - 100;
	daytime = ((hourT > 7) && (hourT < 22));
	return String(temp);
}
time_t NtpTime::getLocalTime_t()
{
	timeval tv;
	timespec tp;
	time_t now;
	gettimeofday(&tv, nullptr);
	now = time(nullptr);
	return now;
}

//Function to print date with time zone
String NtpTime::getLocalDate()
{
	char temp[12];
	time_t tnow = time(nullptr);

	struct tm* local = localtime(&tnow);
	snprintf(temp, sizeof(temp), "%02d %s %02d", local->tm_mday, monthShortStr(local->tm_mon), local->tm_year + 1900);
	return String(temp);
}

//Function to print date with time zone
String NtpTime::getLocalDate(time_t tnow)
{
	char temp[12];

	struct tm* local = localtime(&tnow);
	snprintf(temp, sizeof(temp), "%02d %s %02d", local->tm_mday, monthShortStr(local->tm_mon), local->tm_year + 1900);
	return String(temp);
}

void NtpTime::setupTime() {
	// setup RTC time it will be used until NTP server will send us real current time
	time_t rtc = RTC_UTC_TEST;
	timeval tv = { rtc, 0 };
	timezone tz = { 0, 0 };
	settimeofday(&tv, &tz);

	// NTP servers may be overriden by your DHCP server for a more local one
	configTime(MYTZ, "pool.ntp.org");
}

void NtpTime::setSystemTime() {
	setTime(time(nullptr));
	time_set = true;
}

bool NtpTime::isTimeDaytime(time_t t) {
	Timezone myTZ(myDST, mySTD);

	local = myTZ.toLocal(t, &tcr);
	return ((hour(local) > dayHour) && (hour(local) < nightHour));
}

//Function to print time with time zone from a time_t structure
String NtpTime::printTime(time_t t)
{
	Timezone myTZ(myDST, mySTD);
	String timeStr = "";
	char temp[15];
	bool daytime;

	local = myTZ.toLocal(t, &tcr);
	snprintf(temp, sizeof(temp), "%02d:%02d:%02d", hour(local), minute(local), second(local));
	timeStr += temp;
	return timeStr;
}

NtpTime ntp;
